package org.ten60.wink.persist.endpoint;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.layer0.nkf.NKFException;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.impl.HDSBuilder;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

import java.io.*;
import java.net.URI;
import java.text.DateFormat;
import java.util.Date;

public class EntriesAccessor extends StandardAccessorImpl
{
	public EntriesAccessor()
	{	this.declareThreadSafe();		
	}

	public void onSource(INKFRequestContext aContext) throws Exception
	{	
		String dir=(String)aContext.source("active:HDSXpath+operand@fpds:/etc/WinkConfig.xml+operator@/wink/persistFile/directory/text()", String.class);
		
		HDSBuilder b=new HDSBuilder();
		b.pushNode("entries");
		File dirf=new File(URI.create(dir));
		getDirectoryListing(dirf, b, dirf.toURI());
		aContext.createResponseFrom(b.getRoot());
	}
	
	private void getDirectoryListing(File f, HDSBuilder b, URI base)
	{	for(File i: f.listFiles())
		{	if(i.isDirectory())
			{	getDirectoryListing(i, b, base);
			}
			else if(i.getName().endsWith(".latest"))
			{	URI u=i.toURI();
				u=base.relativize(u);
				String res="res:/wiki/"+u.toString();
				b.addNode("wiki", res.substring(0, res.length()-7));
			}
		}
	}
	
}
